Index: babyftpd.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/babyftpd.cpp,v
retrieving revision 1.71
retrieving revision 1.109
diff -u -p -b -r1.71 -r1.109
--- babyftpd.cpp	10 Jul 2004 14:16:49 -0000	1.71
+++ babyftpd.cpp	22 Jan 2005 23:06:05 -0000	1.109
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: babyftpd.cpp
+//  $Id: babyftpd.cpp,v 1.109 2005/01/22 23:06:05 klas Exp $
+//
 // Usage: main function, commandline parsing and function that
 //        on the main socket.
 //
@@ -15,15 +16,16 @@ int main(int argc, char **argv)
 {
   pid_t pid;
 
+  logging = new class Log;
   // we want the config object created before we parse commandline as that can set stuff.
   config = new class Configuration;
   parse_commandline(argc, argv);
-  openlog("BabyFTPd", LOG_CONS | LOG_PID, LOG_FTP); 
+  // we send the start message for logging here so that starts our log.
+  logging->log_this(3, TYPE_INFO, config->general.welcome_msg + " started.");
   // the config file variable exists in the Configuration class :p
   if(config->parse_config_file() == false)
     cout << "Failed to open the config file (" << config->conf_file << "), check if it exists + permissions." << endl;
   
-  syslog(LOG_INFO, "%s started", config->general.welcome_msg.c_str());
   
   if(config->general.no_daemon == false)
     pid = fork();
@@ -61,47 +63,54 @@ int main(int argc, char **argv)
 
       chdir("/");
       umask(0);
-      /*
+
       close(STDIN_FILENO);
       close(STDOUT_FILENO);
       close(STDERR_FILENO);
-      */
 
-      pthread_mutex_init(&user_list_mutex, NULL);
-      pthread_mutex_init(&sys_log_lock, NULL);
+      // we can't spawn the logging thread until after we are daemonized
+      pthread_create(&logging_thread, NULL, log_wrapper, NULL);
+
+      pthread_key_create(&my_user, kill_user);
+      pthread_key_create(&my_data, kill_data);
 
-      pthread_key_create(&my_object, NULL);
+      sem_init(&user_list_lock, 0, 1);
+      sem_init(&comm.pam_lock, 0, 1);
 
       signal(SIGTERM, sig_handler);
       signal(SIGHUP, sig_handler);
-      signal(SIGABRT, sig_handler);
+      signal(SIGPIPE, sig_handler);
 
       main_thread = pthread_self();
 
 #ifdef USE_TLS
 #warning "TLS ENABLED."
+#ifndef OLD_GCRYPT
+      gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pthread);
+#endif // OLD_GCRYPT
       int ret;
+      sem_init(&cache_lock, 0, 1);
       gnutls_global_init();
 
-      pthread_mutex_init(&cache_lock, NULL);
-
       gnutls_certificate_allocate_credentials(&x509_cred);
       ret = gnutls_certificate_set_x509_trust_file(x509_cred, config->general.tls_ca.c_str(), GNUTLS_X509_FMT_PEM);
       if(ret < 0)
-        gnutls_perror(ret);
+        logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
 
       ret = gnutls_certificate_set_x509_crl_file(x509_cred, config->general.tls_crl.c_str(), GNUTLS_X509_FMT_PEM);
       if(ret < 0)
-        gnutls_perror(ret);
+        logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
       
       ret = gnutls_certificate_set_x509_key_file(x509_cred, config->general.tls_cert.c_str(), config->general.tls_key.c_str(), GNUTLS_X509_FMT_PEM);
       if(ret < 0)
-        gnutls_perror(ret);
-      // this should be setup so it is rerun every couple of hours
+        logging->log_this(2, TYPE_INFO, gnutls_strerror(ret));
+
       gnutls_dh_params_init(&dh_params);
+
       gnutls_dh_params_generate2(dh_params, 1024);
 
       gnutls_certificate_set_dh_params(x509_cred, dh_params);
+      dh_time = time(NULL);
 
 #endif // USE_TLS
       
@@ -113,62 +122,95 @@ int main(int argc, char **argv)
       _exit(0);
       break;
   }
-  closelog();
 }
 
 bool listener(void)
 {
   struct sockaddr_in address;
-  int first_socket;
-  pthread_t thread_tmp;
-  int final_socket;
-  socklen_t socketlen;
+  struct timeval tv = {config->general.lifebeat_tick,0};
   
-  first_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
+  int first_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
   address.sin_family = AF_INET;
   address.sin_addr.s_addr = INADDR_ANY;
   address.sin_port = htons(config->general.port);
-  if(bind(first_socket, (struct sockaddr*)&address, sizeof(address)) < 0)
+  if(bind(first_socket, reinterpret_cast<struct sockaddr*>(&address), sizeof(address)) < 0)
   {
-    cout << "Port " << config->general.port << " already in use." << endl;
-    exit_baby(1);
+    logging->log_this(2, TYPE_INFO, "Port " + util.itos(config->general.port) + " already in use.");
+    exit_baby(1, EXIT_FULL);
   }
+  seteuid(config->general.user);
+  listen(first_socket, LISTEN_LIMIT);
   while(true)
   { 
-    listen(first_socket, LISTEN_LIMIT);
-    socketlen = sizeof(struct sockaddr_in);
-    final_socket = accept(first_socket, (struct sockaddr*)&address, &socketlen);
-    // check for received signals here... at least for signals that should affect anything at this stage :p
-    
-    if(sigs.hup == true)
-      config->parse_config_file(); // careful about this, maybe create a new func, config->reread_config() ?
+    pthread_t thread_tmp;
+    socklen_t socketlen = sizeof(struct sockaddr_in);
+    fd_set sock_set;
+    time_t before = time(NULL);
+
+    FD_ZERO(&sock_set);
+    FD_SET(first_socket, &sock_set);
+    if(!select(first_socket + 1, &sock_set, NULL, NULL, &tv))
+    {
+      lifebeat();
+      tv.tv_sec = config->general.lifebeat_tick; // important to reset lifebeat.
+      continue;
+    }
+
+    int final_socket[0];
+    final_socket[0] = accept(first_socket,
+        reinterpret_cast<struct sockaddr*>(&address), &socketlen);
+    if(final_socket[0] != -1)
+    {
+      pthread_create(&thread_tmp, NULL, user_wrapper,
+          static_cast<void*>(final_socket));
+      pthread_detach(thread_tmp);
+    }
+    else
+      logging->log_this(3, TYPE_INFO, "Failed to accept new caller.");
     
-    pthread_create(&thread_tmp, NULL, wrapper, (void*)final_socket);
-    pthread_detach(thread_tmp); // detaching isn't good, to much mem, we loose the thread idea, is this still true? I think not.
+    tv.tv_sec = config->general.lifebeat_tick - (time(NULL) - before);
   }
   close(first_socket);
   
   return(true);
 }
 
-static void *wrapper(void *socket_id)
+void lifebeat(void)
+{
+  logging->log_this(4, TYPE_DEBUG, "lifebeat reached.");
+
+#ifdef USE_TLS
+  if((time(NULL) - dh_time) > config->general.dh_regenerate)
+  {
+    gnutls_dh_params temp_dh_params;
+    gnutls_dh_params_init(&temp_dh_params);
+    gnutls_dh_params_generate2(temp_dh_params, 1024);
+    dh_params = temp_dh_params;
+    gnutls_certificate_set_dh_params(x509_cred, dh_params);
+    dh_time = time(NULL);
+  }
+#endif // USE_TLS
+}
+
+static void *user_wrapper(void *socket_id)
 {
-  class User *user;
-  pthread_setspecific(my_object, (void*)user);
+  pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
     
-  user = handler.initializer((int)socket_id);
+  class User *user = handler.initializer(static_cast<int>((static_cast<int*>(socket_id)[0])));
+  pthread_setspecific(my_user, static_cast<void*>(user));
   
-  if(user->logged_in != LOGGED_OUT)
     handler.init(user);
   
-  string log = "closed connection from: ";
-  log.append(user->host_name);
-  pthread_mutex_lock(&sys_log_lock);
-  syslog(LOG_DEBUG, log.c_str());
-  pthread_mutex_unlock(&sys_log_lock);
+  logging->log_this(3, TYPE_DEBUG, "closed connection from: " + user->host_name);
+  pthread_exit(NULL); // the thread exits..., and takes the user with it..
+}
+
+static void *log_wrapper(void *not_used)
+{
+  pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
+  logging->log_main();
   
-  delete user; // user object destroyed.
-  pthread_exit(NULL); // the thread exits...
+  pthread_exit(NULL);
 }
 
 void parse_commandline(int argc, char **argv)
@@ -234,7 +276,7 @@ void parse_commandline(int argc, char **
           log_level = 0;
         else
           log_level = atoi(optarg);
-        config->general.log_level = log_level;
+        config->logger.log_level = log_level;
         break;
 
       case 'q':
@@ -280,9 +322,10 @@ void parse_commandline(int argc, char **
       cout << endl;
       cout << "    (*) only hooks for these options in yet, doesn't really work." << endl;
       cout << endl;
-      cout << "Please, report bugs, either directly to the developers or via sourceforge (http://www.sf.net/projects/babyftpd)." << endl;
+      cout << "Please, report bugs, either directly to the developers" << endl;
+      cout << "or via sourceforge (http://www.sf.net/projects/babyftpd)." << endl;
 
-      exit_baby(0);
+      exit_baby(0, EXIT_EARLY);
     }
     
     if(version == true)
@@ -298,7 +341,7 @@ void parse_commandline(int argc, char **
       version_info += "\n";
       
       cout << version_info;
-      exit_baby(0);
+      exit_baby(0, EXIT_EARLY);
     }
   }
 }
@@ -308,84 +351,45 @@ void sig_handler(int signal)
   switch(signal)
   {
     case SIGTERM:
-      pthread_t curr_thread;
-      curr_thread = pthread_self();
+      logging->log_this(3, TYPE_INFO, "SIGTERM received.");
 
-      cout << "thread " << curr_thread << " received SIGTERM" << endl;
-      sigs.term = true;
+      logging->log_this(4, TYPE_DEBUG, "main thread. users: " + util.itos(user_list.size()));
+
+      for(vector<User*>::iterator user_it = user_list.begin(); user_it != user_list.end(); user_it++)
+        pthread_cancel((*user_it)->thread_id);
 
-      if(pthread_equal(curr_thread, main_thread)) // the real stuff...
-      {
         struct timeval times;
         times.tv_sec = 1;
         times.tv_usec = 0;
+      select(0, NULL, NULL, NULL, &times);
         
-        pthread_mutex_lock(&sys_log_lock);
-        syslog(LOG_NOTICE, "SIGTERM received.");
-        pthread_mutex_unlock(&sys_log_lock);
-                    
-        cout << "main thread. users: " << user_list.size() << endl;
-        for(vector<User*>::iterator user_it = user_list.begin(); user_it != user_list.end(); user_it++)
-          pthread_kill((*user_it)->thread_id, SIGTERM);
-
-        select(0, NULL, NULL, NULL, &times); // wait one second before going on and exiting.
-
-        cout << "main thread exiting." << endl; 
-        exit_baby(1);
-      }
-      else
-      {
-        vector<User*>::iterator user_it = get_user_it(curr_thread);
-        if(*user_it != NULL) // this is a user, now let's kill it
-        {
-          pthread_mutex_unlock(&(*user_it)->lock);
-          comm.ftp_send(*user_it, "421 Server shutting down, closing control connection.");
-          delete *user_it;
-        }
-        else // no? then let's assume it's a data object..
-        {
-          class Data *data;
-          data = (Data*)pthread_getspecific(my_object);
-          pthread_mutex_unlock(&data->data_lock);
-          delete data;
-        }
-        pthread_exit(NULL);
-
-      }
+      logging->log_this(3, TYPE_INFO, "main thread exiting.");
+      exit_baby(1, EXIT_FULL);
       break;
 
     case SIGHUP:
-      pthread_mutex_lock(&sys_log_lock);
-      syslog(LOG_NOTICE, "SIGHUP received.");
-      pthread_mutex_unlock(&sys_log_lock);
-      cout << "hup received..." << endl;
-      sigs.hup = true;
+      logging->log_this(3, TYPE_INFO,
+          "SIGHUP received, reloading configuration");
+      config->parse_config_file();
       break;
 
-    case SIGABRT:
-      pthread_mutex_lock(&sys_log_lock);
-      syslog(LOG_NOTICE, "SIGABRT received.");
-      pthread_mutex_unlock(&sys_log_lock);
-      cout << "abort received..." << endl;
-      sigs.abort = true;
+    case SIGPIPE:
+      logging->log_this(3, TYPE_INFO,
+          "SIGPIPE received in thread: " + util.itos(pthread_self()));
+      if(!pthread_equal(pthread_self(), main_thread) ||
+          pthread_equal(pthread_self(), logging_thread))
+        pthread_exit(NULL); // if this is a user or data thread, bail.
       break;
   }
 }
 
-
-Signals::Signals()
+void exit_baby(int num, int how)
 {
-  Signals::hup = false;
-  Signals::term = false;
-  Signals::abort = false;
-}
 
-void exit_baby(int num)
-{
-  pthread_mutex_destroy(&user_list_mutex);
-  pthread_mutex_destroy(&sys_log_lock);
-  pthread_key_delete(my_object);
-  delete config;
+  if(how == EXIT_FULL)
+  {
+    pthread_key_delete(my_user);
+    pthread_key_delete(my_data);
 
 #ifdef USE_TLS
   // emptying and freeing session cache.
@@ -397,11 +401,19 @@ void exit_baby(int num)
     cache_db.erase(cache_it);
   }
   
-  pthread_mutex_destroy(&cache_lock);
+    gnutls_dh_params_deinit(dh_params);
   gnutls_certificate_free_credentials(x509_cred);
   gnutls_global_deinit();
+    sem_destroy(&cache_lock);
 #endif // USE_TLS
+    sem_destroy(&comm.pam_lock);
+    sem_destroy(&user_list_lock);
+    pthread_cancel(logging_thread);
+    pthread_join(logging_thread, NULL);
+  }
+  delete(logging);
 
+  delete config;
   exit(num);
 }
 
@@ -411,17 +423,17 @@ int tls_db_store(void *dbf, gnutls_datum
 {
   struct cache *temp_cache = new cache;
   
-  (void*)temp_cache->key.data = gnutls_malloc(key.size);
+  temp_cache->key.data = static_cast<unsigned char*>(gnutls_malloc(key.size));
   temp_cache->key.size = key.size;
   memcpy(temp_cache->key.data, key.data, key.size);
 
-  (void*)temp_cache->data.data = gnutls_malloc(data.size);
+  temp_cache->data.data = static_cast<unsigned char*>(gnutls_malloc(data.size));
   temp_cache->data.size = data.size;
   memcpy(temp_cache->data.data, data.data, data.size);
   
-  pthread_mutex_lock(&cache_lock);
+  sem_wait(&cache_lock);
   cache_db.push_back(temp_cache);
-  pthread_mutex_unlock(&cache_lock);
+  sem_post(&cache_lock);
   return(0);
 }
 
@@ -433,7 +445,7 @@ gnutls_datum tls_db_fetch(void *dbf, gnu
     if(memcmp(key.data, (*cache_it)->key.data, (*cache_it)->key.size) == 0)
     {
       data.size = (*cache_it)->data.size;
-      (void*)data.data = gnutls_malloc(data.size);
+      data.data = static_cast<unsigned char*>(gnutls_malloc(data.size));
       memcpy(data.data, (*cache_it)->data.data, data.size);
       break;
     }
@@ -446,12 +458,12 @@ int tls_db_delete(void *dbf, gnutls_datu
   for(vector<cache*>::iterator cache_it = cache_db.begin(); cache_it != cache_db.end(); cache_it++)
     if(memcmp(key.data, (*cache_it)->key.data, (*cache_it)->key.size) == 0)
     {
-      pthread_mutex_lock(&cache_lock);
+      sem_wait(&cache_lock);
       gnutls_free((*cache_it)->key.data);
       gnutls_free((*cache_it)->data.data);
       delete(*cache_it);
       cache_db.erase(cache_it);
-      pthread_mutex_unlock(&cache_lock);
+      sem_post(&cache_lock);
       return(0);
     }
         
Index: babyftpd.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/babyftpd.h,v
retrieving revision 1.31
retrieving revision 1.47
diff -u -p -b -r1.31 -r1.47
--- babyftpd.h	10 Jul 2004 14:14:45 -0000	1.31
+++ babyftpd.h	18 Jan 2005 22:44:36 -0000	1.47
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: babyftpd.h
+// $Id: babyftpd.h,v 1.47 2005/01/18 22:44:36 klas Exp $
+//
 // Usage: main function, commandline parsing and function that
 //        on the main socket.
 //
@@ -17,41 +18,45 @@
 #include "Handler.h"
 #include "Commands.h"
 #include "Utilities.h"
-#endif
+#include "Log.h"
+#ifdef USE_TLS
+#include "tls.cpp"
+#endif // USE_TLS
+#endif // __BABYFTPD_CPP__
 
-static void *wrapper(void*);
+static void *user_wrapper(void*) __attribute__ ((noreturn));
+static void *log_wrapper(void*) __attribute__ ((noreturn));
 bool listener(void);
 void parse_commandline(int, char**);
 void sig_handler(int);
-void exit_baby(int);
-
-class Signals
-{
-  public:
-    Signals();
-    bool term;
-    bool hup;
-    bool abort;
-} sigs;
+void exit_baby(int, int);
+void lifebeat(void);
 
 class Configuration *config;
 class Handler handler;
 class Commands comm;
 class Utilities util;
+class Log *logging;
 
 // thread specific storage..
-pthread_key_t my_object = 0;
+pthread_key_t my_user = 0;
+pthread_key_t my_data = 0;
 
-pthread_mutex_t sys_log_lock;
-pthread_mutex_t user_list_mutex;
+sem_t user_list_lock;
 pthread_t main_thread; // for managing on shutdown and signal handling.
+pthread_t logging_thread; // so we can join it.
 vector<User*> user_list;
 
 #define LISTEN_LIMIT 5
 
+// for exit_baby()
+#define EXIT_EARLY 1
+#define EXIT_FULL  2
+
 #ifdef USE_TLS
 gnutls_certificate_credentials x509_cred;
 static gnutls_dh_params dh_params;
+time_t dh_time;
 int tls_db_store(void*, gnutls_datum, gnutls_datum);
 gnutls_datum tls_db_fetch(void*, gnutls_datum);
 int tls_db_delete(void*, gnutls_datum);
@@ -63,7 +68,7 @@ struct cache
 };
 
 vector<cache*> cache_db;
-pthread_mutex_t cache_lock;
+sem_t cache_lock;
 #endif // USE_TLS
 
 #endif
Index: commands.hlp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/commands.hlp,v
retrieving revision 1.3
retrieving revision 1.4
diff -u -p -b -r1.3 -r1.4
--- commands.hlp	10 Jul 2004 14:14:45 -0000	1.3
+++ commands.hlp	10 Jul 2004 17:22:27 -0000	1.4
@@ -3,7 +3,7 @@
 #define HLP_RETR " <file> (sends a file over a data connection)"
 #define HLP_STOR " <file> (receives a file over a data connection)"
 #define HLP_PORT " <a1,a2,a3,a4,p1,p2> (specify client data port)"
-#define HLP_EPRT " |protocol|adress|port| (specify client data adress and port)"
+#define HLP_EPRT " <|protocol|adress|port|> (specify client data adress and port)"
 #define HLP_QUIT " (logout)"
 #define HLP_LIST " <path> (lists a directory or file(s))"
 #define HLP_TYPE " <type> (sets the transfer type for future transfers)"
Index: config.h.in
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/config.h.in,v
retrieving revision 1.6
retrieving revision 1.11
diff -u -p -b -r1.6 -r1.11
--- config.h.in	10 Jul 2004 14:14:45 -0000	1.6
+++ config.h.in	18 Jan 2005 22:57:04 -0000	1.11
@@ -1,4 +1,5 @@
 /* config.h.in.  Generated from configure.in by autoheader.  */
+/* $Id: config.h.in,v 1.11 2005/01/18 22:57:04 klas Exp $ */
 
 /* Define to 1 if you have the <dirent.h> header file, and it defines `DIR'.
    */
@@ -10,8 +11,8 @@
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
-/* Define to 1 if you have the `crypt' library (-lcrypt). */
-#undef HAVE_LIBCRYPT
+/* Define to 1 if you have the `pam' library (-lpam). */
+#undef HAVE_LIBPAM
 
 /* Define to 1 if you have the `pthread' library (-lpthread). */
 #undef HAVE_LIBPTHREAD
@@ -77,3 +78,9 @@
 
 /* Define to use TLS */
 #undef USE_TLS
+
+/* Define to mark libgcrypt being 1.1.92 or older */
+#undef OLD_GCRYPT
+
+/* Define to use new format for list */
+#undef USE_NEWLS
Index: configure.in
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/configure.in,v
retrieving revision 1.13
retrieving revision 1.24
diff -u -p -b -r1.13 -r1.24
--- configure.in	10 Jul 2004 14:14:45 -0000	1.13
+++ configure.in	16 Jan 2005 11:16:24 -0000	1.24
@@ -1,6 +1,8 @@
 dnl Process this file with autoconf to produce a configure script.
-AC_PREREQ(2.57)
+dnl $Id: configure.in,v 1.24 2005/01/16 11:16:24 klas Exp $
+AC_PREREQ(2.50)
 AC_INIT(babyftpd)
+AC_LANG(C++)
 AC_CONFIG_SRCDIR(babyftpd.cpp)
 AC_CONFIG_HEADER(config.h)
   
@@ -11,8 +13,10 @@ AC_PROG_CXXCPP
 AC_PROG_MAKE_SET
 
 dnl Checks for libraries.
-AC_CHECK_LIB(crypt, crypt)
 AC_CHECK_LIB(pthread, pthread_create)
+if test "x$ac_cv_lib_pthread_pthread_create" != "xyes" ; then
+  AC_MSG_ERROR(babyftpd needs a working pthreads package.)
+fi
 
 dnl Checks for header files.
 AC_HEADER_DIRENT
@@ -26,19 +30,70 @@ AC_TYPE_UID_T
 
 dnl Checks for library functions.
 
+dnl babystuff
+AC_MSG_CHECKING(whether there is a cradle present)
+AC_MSG_RESULT(yes)
+
+AC_MSG_CHECKING(if we have to use a pacifier)
+AC_MSG_RESULT(yes)
+
+AC_MSG_CHECKING(if the gruel is still hot enough)
+AC_MSG_RESULT(yes)
+
+AC_MSG_CHECKING(for poop in -ldiaper)
+AC_MSG_RESULT(no (wheew!))
+
 dnl Commandline enabling/disabling
 AC_ARG_ENABLE(tls,
     [AC_HELP_STRING([--disable-tls],[Disable the use of tls for encryption.])],
     [ if test "x$enableval" = "xyes"; then
-      AC_CHECK_LIB(gnutls, gnutls_init, 
-      AC_DEFINE(USE_TLS,,[tls enable])
+      AC_CHECK_LIB(gnutls, gnutls_dh_params_generate2, 
+      AC_DEFINE(USE_TLS 1,,[tls enable])
       LIBS="$LIBS -lgnutls"
       )
     fi],
-    AC_CHECK_LIB(gnutls, gnutls_init,
-    AC_DEFINE(USE_TLS,,[tls enable])
+    AC_CHECK_LIB(gnutls, gnutls_dh_params_generate2,
+    AC_DEFINE(USE_TLS 1,,[tls enable])
     LIBS="$LIBS -lgnutls"
     )
 )
 
+AC_ARG_ENABLE(newls,
+    [AC_HELP_STRING([--enable-newls],[Enable use of new format for list (yyyy-mm-dd hh:mm).])],
+    [ if test "x$enableval" = "xyes"; then
+      AC_DEFINE(USE_NEWLS 1,,[newls enable])
+      fi]
+)
+
+AC_MSG_CHECKING(if we have to tell gcrypt what threads package we are running)
+AC_RUN_IFELSE([AC_LANG_SOURCE([[
+#ifdef USE_TLS
+#include <gcrypt.h>
+#endif
+
+int main(void)
+{
+  int ret;
+#ifdef USE_TLS
+  if(gcry_check_version("1.1.93"))
+    ret = 1;
+  else
+#endif
+    ret = 0;
+  return(ret);
+}
+      ]])],[
+AC_MSG_RESULT(no)
+AC_DEFINE(OLD_GCRYPT 1,,[ Define to mark libgcrypt being 1.1.92 or older])
+],[AC_MSG_RESULT(yes)
+],[])
+
+dnl PAM stuff..
+AC_CHECK_HEADERS(security/pam_appl.h)
+if test "x$ac_cv_header_security_pam_appl_h" != "xyes" ; then
+  AC_MSG_ERROR(PAM headers not found.)
+else
+  AC_CHECK_LIB(pam, pam_start)
+fi
+
 AC_OUTPUT(Makefile)
Index: generic.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/generic.h,v
retrieving revision 1.59
retrieving revision 1.76
diff -u -p -b -r1.59 -r1.76
--- generic.h	10 Jul 2004 14:14:45 -0000	1.59
+++ generic.h	22 Jan 2005 23:06:05 -0000	1.76
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: generic.h
+//  $Id: generic.h,v 1.76 2005/01/22 23:06:05 klas Exp $
+//
 // Usage: some defines that is important for correct inclusions of
 //        system headers, and all system header includes.
 //
@@ -12,9 +13,11 @@
 
 #define __USE_GNU 1
 
-#include <iostream>
-#include <syslog.h>
 #include "config.h"
+#include <unistd.h>
+#include <string>
+#include <vector>
+#include <semaphore.h>
 
 #ifdef __NETINCLS__
 #include <sys/socket.h>
@@ -24,38 +27,44 @@
 #if (!defined(__STRINGTOKENIZER_H__) && !defined(__CONFIGURATION_H__) && !defined(__UTILITIES_H__))
 #include <pthread.h>
 #include <cerrno>
-#include <vector>
+#include <bitset>
+#include <security/pam_appl.h>
 #ifdef USE_TLS
 #include <gnutls/gnutls.h>
 #endif // USE_TLS
+using std::bitset;
 #endif // stuff...
 
-#ifdef __STRINGTOKENIZER_H__
-#include <string>
-#endif // __STRINGTOKENIZER_H__
-
 #ifdef __UTILITIES_H__
-#include <cctype>
 #include <sys/stat.h>
-#include <string>
 #endif // __UTILITIES_H__
 
 #ifdef __BABYFTPD_H__
 #include <csignal>
 #include <getopt.h>
 #include <sys/stat.h>
+#include <iostream>
+using std::cout;
+using std::endl;
+#ifdef USE_TLS
+#ifndef OLD_GCRYPT
+#include <gcrypt.h>
+#endif // OLD_GCRYPT
+#endif // USE_TLS
 #endif // __BABYFTPD_H__
 
 #ifdef __HANDLER_H__
 #include <csignal>
 #include <netdb.h>
+#include <algorithm>
 #endif // __HANDLER_H__
 
 #ifdef __CONFIGURATION_H__
 #include <sys/utsname.h>
 #include <fstream>
 #include <climits>
-#include <string>
+#include <pwd.h>
+using std::ifstream;
 #endif // __CONFIGURATION_H__
 
 #ifdef __COMMANDS_H__
@@ -69,9 +78,23 @@
 #include <crypt.h>
 #include <dirent.h>
 #include <fcntl.h>
+#include <algorithm>
 #endif // __COMMANDS2_CPP__
 
-using namespace std;
+#ifdef __LOG_H__
+#include <syslog.h>
+#include <fstream>
+using std::ofstream;
+using std::endl;
+#endif // __LOG_H__
+
+#ifdef __USER_H__
+#include <security/pam_appl.h>
+#include <security/pam_misc.h>
+#endif // __USER_H__
+
+using std::string;
+using std::vector;
 
 class Configuration;
 class User;
@@ -87,11 +110,4 @@ class StringTokenizer;
 #define FTP_LOG DAEMON_LOG
 #endif // FTP_LOG
 
-#define test(a, b)            (((a) & (b)) == (b))
-#define change(a)             ((a == 0) ? (a = 1) : (a = 0))
-#define is_set(flag, bit)     ((flag) & (bit))
-#define set_bit(flag, bit)    ((flag) |= (bit))
-#define remove_bit(flag, bit) ((flag) &= ~(bit))
-#define toggle(flag, bit)     ((flag) ^= (bit))
-
 #endif
Index: tls.cpp
===================================================================
RCS file: tls.cpp
diff -N tls.cpp
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ tls.cpp	18 Jan 2005 22:44:37 -0000	1.1
@@ -0,0 +1,59 @@
+/////////////////////////////////////////////////////////////////////
+// $Id: tls.cpp,v 1.1 2005/01/18 22:44:37 klas Exp $
+//
+// Shamelessly ripped code from gcrypt.h, modified for c++.
+//   Included when we have new gcrypt and need to tell it how to do
+//   thread locking for us.
+//
+// A part of babyftpd, licensed under the GNU GPL, see the file
+//   LICENSE for complete information.
+//
+////////////////////////////////////////////////////////////////////
+
+#ifndef OLD_GCRYPT
+
+static int gcry_pthread_mutex_init (void **priv)
+{
+  int err = 0;
+  pthread_mutex_t *lock = new pthread_mutex_t;
+  if (!lock)
+    err = ENOMEM;
+  if (!err)
+  {
+    err = pthread_mutex_init (lock, NULL);
+    if (err)
+      delete lock;
+    else
+      *priv = lock;
+  }
+  return err;
+}
+
+static int gcry_pthread_mutex_destroy (void **lock)
+{
+  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
+  int err = pthread_mutex_destroy(temp_lock);
+  delete temp_lock;
+  return err;
+}
+
+static int gcry_pthread_mutex_lock (void **lock)
+{
+  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
+  return pthread_mutex_lock(temp_lock);
+}
+
+static int gcry_pthread_mutex_unlock (void **lock)
+{
+  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
+  return pthread_mutex_unlock(temp_lock);
+}
+
+static struct gcry_thread_cbs gcry_threads_pthread =
+{
+  GCRY_THREAD_OPTION_PTHREAD, NULL,
+  gcry_pthread_mutex_init, gcry_pthread_mutex_destroy,
+  gcry_pthread_mutex_lock, gcry_pthread_mutex_unlock
+};
+
+#endif // OLD_GCRYPT
Index: examples/babyftpd.conf
===================================================================
RCS file: examples/babyftpd.conf
diff -N examples/babyftpd.conf
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ examples/babyftpd.conf	22 Jan 2005 23:06:05 -0000	1.4
@@ -0,0 +1,92 @@
+# $Id: babyftpd.conf,v 1.4 2005/01/22 23:06:05 klas Exp $
+# General section, for... general stuff
+general
+{
+  # port 21 - standard ftp port.
+  port 21
+
+  # admin email
+  admin_email you@your.host
+
+  # maximum number of control connections.
+  connection_limit 100
+
+  # run the lifebeat() every this seconds
+  lifebeat_tick 300
+
+  #TLS stuff
+  tls_key /root/tls_key.pem
+  tls_cert /root/tls_cert.pem
+  tls_ca /root/tls_ca.pem
+  tls_crl /root/tls_crl.pem
+
+  # how often to regenerate diffie-hellman parameters (in seconds)
+  dh_regenerate 3600
+
+  # what user to run the process under?
+  user ftp
+}
+
+# user section, for... user stuff
+user
+{
+  # and a user general section, for... user general stuff
+  # all options for single users can be used in this section as well, they will then
+  #   affect all users. options on specific users override general options.
+  general
+  {
+    # number of control connections/user
+    user_limit 5
+
+    # number of simultaneously open data connections/control connection (list & nlst excluded)
+    sim_data 3
+
+    # encryption:
+    encryption allow
+  }
+
+  # a per user section for... per user stuff.
+  root
+  {
+    # this useer is not allowed to login
+    noftp 1
+  }
+
+  berra
+  {
+    # this user can only see/touch tis /her/it's home directory
+    only_home 1
+
+    # this user can only use passive data transfers
+    only_passive 1
+
+    user_limit 2
+
+    # encryption can have several values..
+    encryption deny
+  }
+}
+
+log
+{
+  # a default loglevel of 3 is neat
+  log_level 3
+
+  # by default we want xferlogging
+  xferlog 1
+
+  # xferlogging go to /var/log/xferlog
+  xferlog_file /var/log/xferlog
+
+  # authlog by way of syslog
+  authlog syslog
+
+  # info also by way of syslog
+  infolog syslog
+
+  # and debug as well
+  debuglog syslog
+
+  # thread id on all logging..
+  thread_id 1
+}
Index: examples/babyftpd.pam
===================================================================
RCS file: examples/babyftpd.pam
diff -N examples/babyftpd.pam
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ examples/babyftpd.pam	23 Jan 2005 00:39:50 -0000	1.2
@@ -0,0 +1,10 @@
+# $Id: babyftpd.pam,v 1.2 2005/01/23 00:39:50 klas Exp $
+# put this file or one like it in /etc/pam.d/ with the name babyftpd.
+# 
+# babyftpd should work with most kinds of pam modules. Extensive testing
+#  hasn't taken place yet, if you have trouble getting pam modules that
+#  should work with babyftpd to work, contact us.
+
+auth    required        pam_unix.so nullok_secure
+account required        pam_unix.so
+session required        pam_unix.so
